elementTables = {}

# first 3 letters of element type followed by a '-', floor number plus 2 numbers
infoStringFormat = '{:.3}-{}{:02d}'

for elemGuid in GetSelectedElements ():
	elemHead = GetElementHeader (elemGuid)
	elementTables.setdefault (elemHead.typeID, {}).setdefault (elemHead.floorInd, []).append (elemGuid)

with UndoScope ("Changing Info Strings"):
	for elemType in elementTables.keys ():
		elemTypeName = GetElementTypeName (elemType)
		for (floorInd, elemGuids) in elementTables[elemType].items ():
			count = 0
			for elemGuid in elemGuids:
				count += 1
				infoString = infoStringFormat.format (elemTypeName, floorInd, count).upper ()
				ChangeInfoString (elemGuid, infoString)
			print ("Changed {} info string(s) of {}(s) on floor {}".format (count, elemTypeName, floorInd))
