import os
import sys
import re

scriptDir = os.path.dirname (sys.argv[0])
file = os.path.join (scriptDir, "LayoutBook.txt")

if os.path.isfile (file) is False:
	sys.exit ("File does not exists: {}".format (file))

layoutTree = GetNavigatorTree (API_LayoutMap)
parentChildDict = dict()

def GetItemsFromTree (tree, t):
	l = []
	for k in tree.keys():
		if k.itemType == t:
			l.append (k)
		l.extend (GetItemsFromTree (tree[k], t))
	return l

def FindItemByName (items, name):
	for item in items:
		if item.name == name:
			return item
	return list(layoutTree)[0]

def FindParentItemByName (name):
	return FindItemByName (GetItemsFromTree (layoutTree, API_SubSetNavItem), name)
def FindChildItemByName (name):
	return FindItemByName (GetItemsFromTree (layoutTree, API_LayoutNavItem), name)

masters = GetItemsFromTree (layoutTree, API_MasterLayoutNavItem)

with open (file) as f:
	for line in f.read().splitlines():
		regExpMatch = re.compile ("^Subset (.*), Parent: (.*)$").match (line)

		if regExpMatch != None:
			subsetName = regExpMatch.group (1)
			parentName = regExpMatch.group (2)
			print("Subset {}, Parent: {}".format (subsetName, parentName))

			newSubSet = APIObject ()
			newSubSet.name = subsetName
			newSubSet.itemType = API_SubSetNavItem
			newSubSet.mapId = API_LayoutMap
			CreateNavigatorItem (newSubSet, FindParentItemByName (parentName))
		else:
			regExpMatch = re.compile ("^(.*), Master: (.*), Parent: (.*)$").match (line)
			if regExpMatch != None:
				layoutName = regExpMatch.group (1)
				masterName = regExpMatch.group (2)
				parentName = regExpMatch.group (3)
				print("{}, Master: {}, Parent: {}".format (layoutName, masterName, parentName))

				newLayout = APIObject ()
				newLayout.name = layoutName
				newLayout.itemType = API_LayoutNavItem
				newLayout.mapId = API_LayoutMap
				newLayout.db = APIObject ()
				newLayout.db.typeID = APIWind_LayoutID
				masterLayoutItem = FindItemByName (masters, masterName)
				newLayout.db.masterLayoutUnId = masterLayoutItem.db.databaseUnId
				if parentName not in parentChildDict:
					CreateNavigatorItem (newLayout, FindParentItemByName (parentName))
					parentChildDict[parentName] = list()
				else:
					CreateNavigatorItem (newLayout, FindParentItemByName (parentName), FindChildItemByName(parentChildDict[parentName][-1]))
				parentChildDict[parentName].append(layoutName)

		if regExpMatch != None:
			layoutTree = GetNavigatorTree (API_LayoutMap)
